#include<iostream>
#include<algorithm>
#include<stdio.h>
#include<vector>
using namespace std;
struct treap {
    int x,y;
    int num,max1;
    treap *l,*r;
};
void update (treap* t) {
     if (t==NULL) return ;
     int max1=t->num;
     if (t->l!=NULL) max1=max(max1,t->l->max1);
     if (t->r!=NULL) max1=max(max1,t->r->max1);
     t->max1=max1;
}
void merge1 (treap *&t, treap *l, treap *r) {
     if ((l==NULL)||(r==NULL)) {
        if (l!=NULL) t=l;
        else t=r;
        return ;
        }
     if (l->y>r->y) t=l, merge1(t->r,l->r,r);
     else t=r, merge1(t->l,l,r->l);
     update(t);
}
void split (treap *t, int x, treap *&l, treap *&r) {
     if (t==NULL) {
        l=r=NULL;
        return ;
        }
    if (t->x<x) l=t, split(t->r,x,l->r,r), update(l);
    else r=t, split(t->l,x,l,r->l), update(r);
}
void insert1 (treap *&t, int x, int y, int num) {
     treap *l,*r,*ex;
     split(t,x,l,r);
     ex=new treap; ex->l=ex->r=NULL;
     ex->num=ex->max1=num;
     ex->x=x; ex->y=y;
     merge1(t,l,ex);
     merge1(t,t,r);
}
/*void print (treap *t) {
     cout << t->x << " " << t->y << " " << t->max1 << " " << t->num << "    ";
     if (t->l!=NULL) cout << "left: " << t->l->x << " " << t->l->y << " " << t->max1 << " " << t->num << "    ";
     if (t->r!=NULL) cout << "right: " << t->r->x << " " << t->r->y << " " << t->max1 << " " << t->num ;
     cout << endl ;
     if (t->l!=NULL) print(t->l);
     if (t->r!=NULL) print(t->r);
}*/

struct tree {
    treap* ys;
};
int cnt[100001],ans,rnd;
tree tr[500001];
void work (int ind, int from, int to, int num) {
    //cout << ind << " " << from << " " << to << " " << num << endl ;
    if ((from==to)&&(from==num)) {
       insert1(tr[ind].ys,cnt[num],rnd,ans+1);
       return ;
       }
    if (to<num) {
       treap *l,*r;
       split(tr[ind].ys,cnt[num],l,r);
       //cout << "a" << l->max1 << "a";
       if (l!=NULL) ans=max(ans,l->max1);
       merge1(tr[ind].ys,l,r);
       return ;
       }
    work(2*ind+1,from,(from+to)/2,num);
    if ((from+to)/2+1<=num) work(2*ind+2,(from+to)/2+1,to,num);
    insert1(tr[ind].ys,cnt[num],rnd,ans+1);
}
vector <int> nums;
int main () {
    int n,i,num,max1=1;
    cin >> n ;
    for (i=0; i<n; i++) {
        scanf("%d",&num);
        cnt[num]=i;
        }
    srand(0);
    for (i=0; i<n; i++) {
        nums.push_back(i);
        }
    random_shuffle(nums.begin(),nums.end());
    for (i=0; i<n; i++) {
        scanf("%d",&num);
        ans=0; rnd=nums[i];
        work(0,0,n-1,num);
        max1=max(max1,ans+1);
        }
    cout << max1 ;
    cout << endl ;
    return 0;
}
